package com.example.witsystem_device_plugin.SDK;

import android.bluetooth.BluetoothDevice;
import android.util.Log;

import com.alibaba.fastjson.JSON;
import com.example.witsystem_device_plugin.SDK.context.FlutterContext;
import com.example.witsystem_device_plugin.SDK.context.FlutterInterface;
import com.witsystem.top.witsystem_android_ble_sdk.device.WitsystmBleSDK;
import com.witsystem.top.witsystem_android_ble_sdk.device.call.BleCallBack;
import com.witsystem.top.witsystem_android_ble_sdk.device.call.BleUnlockCallBack;
import com.witsystem.top.witsystem_android_ble_sdk.error.BluetoothIsNotOn;
import com.witsystem.top.witsystem_android_ble_sdk.error.BluetoothNotSupported;
import com.witsystem.top.witsystem_android_ble_sdk.error.GpsNotOpen;
import com.witsystem.top.witsystem_android_ble_sdk.error.LessPermissions;

import java.util.List;

import SDK.model.Devices;

/**
 * 开启附近的设备
 */
public class BleUnlock implements FlutterInterface<String>, BleUnlockCallBack<Devices> {

    private static final String TAG = "开锁";

    private FlutterContext<String> flutterContext;

    private final WitsystmBleSDK witsystmBleSDK;

    private String deviceId;

    //开启附近设备
    public BleUnlock(WitsystmBleSDK witsystmBleSDK) {
        this.witsystmBleSDK = witsystmBleSDK;
    }

    //开启指定设备
    public BleUnlock(WitsystmBleSDK witsystmBleSDK, String deviceId) {
        this.witsystmBleSDK = witsystmBleSDK;
        this.deviceId = deviceId;
    }

    @Override
    public boolean dataHandle(FlutterContext<String> flutterContext) {
        this.flutterContext = flutterContext;
        return true;
    }

    @Override
    public boolean execute() {
        try {
            Log.i(TAG, "execute: 开门"+ witsystmBleSDK);
            if (deviceId == null) {
                witsystmBleSDK.getUnlock().bleUnlock(this);
            } else {
                witsystmBleSDK.getUnlock().bleUnlock(deviceId, this);
            }
        } catch (BluetoothIsNotOn bluetoothIsNotOn) {
            bluetoothIsNotOn.printStackTrace();
            flutterContext.getResult().error(bluetoothIsNotOn.getCode() + "", bluetoothIsNotOn.getMessage(), null);
        } catch (GpsNotOpen gpsNotOpen) {
            gpsNotOpen.printStackTrace();
            flutterContext.getResult().error(gpsNotOpen.getCode() + "", gpsNotOpen.getMessage(), null);
        } catch (LessPermissions lessPermissions) {
            lessPermissions.printStackTrace();
            flutterContext.getResult().error(lessPermissions.getCode() + "", lessPermissions.getMessage(), null);
        } catch (BluetoothNotSupported bluetoothNotSupported) {
            bluetoothNotSupported.printStackTrace();
            flutterContext.getResult().error("-1", bluetoothNotSupported.getMessage(), null);
        }
        return true;
    }

    @Override
    public String result() {
        return "SUCCESS";
    }

    @Override
    public void success(Devices devices) {
        Log.i(TAG, "success: 开锁成功：" + devices.getDeviceName());
        flutterContext.getResult().success(JSON.toJSON(devices));
    }

    @Override
    public void fail(int i, String err) {
        Log.i(TAG, "success: 开锁失败" + err);
        flutterContext.getResult().error(i + "", err, null);
    }

    @Override
    public void foundMultipleDevices(List<BluetoothDevice> list) {

    }
}
