package com.example.witsystem_device_plugin.SDK.context;


import android.content.Context;

import io.flutter.plugin.common.MethodChannel;

/**
 * 通讯方法的上线文
 */
public class FlutterContext<T> {

    private final Context context;
    private final MethodChannel.Result result;

    public FlutterContext(Context context, MethodChannel.Result result) {
        this.context = context;
        this.result = result;
    }

    public Context getContext() {
        return context;
    }

    public MethodChannel.Result getResult() {
        return result;
    }

    public T exe(FlutterInterface<T> flutterInterface) {
        if (!flutterInterface.dataHandle(this)) {//判断如果执行失败直接返回结果
            return flutterInterface.result();
        }
        flutterInterface.execute();
        return flutterInterface.result();
    }


}
