package com.example.witsystem_device_plugin.SDK.event;


import android.util.Log;

import com.alibaba.fastjson.JSON;

import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.EventChannel;

/**
 * 处理添加设备handler
 */
public class AddDeviceHandler implements EventChannel.StreamHandler {

    private EventChannel.EventSink events;

    @Override
    public void onListen(Object arguments, EventChannel.EventSink events) {
        this.events = events;
    }

    @Override
    public void onCancel(Object arguments) {
    }

    synchronized public void onScanResult(Map<String, Object> json) {
        if (events != null) {
            events.success(JSON.toJSONString(json));
        }
    }

    synchronized public void onError(int code, String error, Exception e) {
        if (events != null) {
            events.error(
                    String.valueOf(code),
                    error,
                    JSON.toJSONString(e));
            //events.endOfStream();
        }
    }

    synchronized public void onComplete() {
        if (events != null) {
            events.endOfStream();
        }
    }
}
