package com.example.witsystem_device_plugin.SDK.event;


import com.alibaba.fastjson.JSON;

import java.util.Map;

import io.flutter.plugin.common.EventChannel;

/**
 * 处理设备通过蓝牙添加handler
 */
public class BleAddMarkHandler implements EventChannel.StreamHandler {

    private EventChannel.EventSink events;

    @Override
    public void onListen(Object arguments, EventChannel.EventSink events) {
        this.events = events;
    }

    @Override
    public void onCancel(Object arguments) {
    }

    synchronized public void onProgressResult(Object json) {
        if (events != null) {
            events.success(JSON.toJSONString(json));
        }
    }

    synchronized public void onError(String code, String error, Object e) {
        if (events != null) {
            events.error(
                    code,
                    error,
                    JSON.toJSONString(e));
            //events.endOfStream();
        }
    }

    synchronized public void onComplete() {
        if (events != null) {
            events.endOfStream();
        }
    }
}
