import 'dart:async';
import 'dart:convert' as convert;
import 'package:flutter/services.dart';
import 'package:witsystem_device_plugin/WitsystemSDK.dart';

import '../MethodName.dart';

/// 添加设备

class AddDevice extends WisystemSDk {
  final Stream<Map<String, dynamic>> _restoreStateEvents =
      const EventChannel(ChannelName.multipleAddDevice)
          .receiveBroadcastStream()
          //   .handleError((errorJson) {
          // var e = errorJson as PlatformException;
          // throw  convert.json.decode(e.details);
          //    })
          .map((event) => convert.json.decode(event.toString()));

  factory AddDevice() => _getInstance();

  static AddDevice get instance => _getInstance();
  static AddDevice? _instance;

  AddDevice._internal();

  static AddDevice _getInstance() {
    _instance ??= AddDevice._internal();
    return _instance!;
  }

  ///扫描可以添加的设备
  Stream<Map<String, dynamic>> scanAddBleDevice() {
    StreamController<Map<String, dynamic>> _streamController =
        StreamController.broadcast(onListen: () {
      //启动监听启动扫描
      methodChannel
          .invokeMethod(MethodName.scanAddBleDevice)
          .catchError((err) => {})
          .then((value) => {});
    }, onCancel: () {
      methodChannel.invokeMethod(MethodName.stopAddBleDevice); //取消监听停止扫描
    });

    _streamController
        .addStream(_restoreStateEvents, cancelOnError: true)
        .then((value) => _streamController.close());
    return _streamController.stream;
  }

  ///停止扫描添加设备
  stopAddBleDevice(StreamSubscription? listen) async {
    if (listen != null) listen.cancel(); //取消监听自动停止扫描
  }

  ///添加
  addBleDevice(String deviceId) async {
    final map = {"deviceId": deviceId};
    return await methodChannel.invokeMethod(MethodName.addBleDevice, map);
  }
}
