 ///开锁对象
import 'package:flutter/services.dart';
import 'dart:convert' as convert;
import '../WitsystemSDK.dart';

class Unlock extends WisystemSDk {
  factory Unlock() => _getInstance();

  static Unlock get instance => _getInstance();
  static Unlock? _instance;

  Unlock._internal();

  static Unlock _getInstance() {
    _instance ??= Unlock._internal();
    return _instance!;
  }

  ///开启附近设备
  bleUnlocks(
      {Function(Map map)? success,
      Function(Map map)? foundMultipleDevices,
      Function(PlatformException e)? fail}) async {
    try {
      String json = await methodChannel.invokeMethod("bleUnlock");
      Map<String, dynamic> map = convert.json.decode(json);
      switch (map['type']) {
        case 'DEVICES':
          if (foundMultipleDevices != null) foundMultipleDevices(map);
          break;
        case 'UNLOCK':
          if (success != null) success(map);
          break;
      }
    } catch (e) {
      if (fail != null) fail(e as PlatformException);
    }
  }


  ///开启指定设备 deviceId代表开启指定设备
  bleUnlock(String deviceId) async {
    final map = {"deviceId": deviceId};
    return await methodChannel.invokeMethod("bleUnlock", map);
  }

}
